#ifndef CoCoA_interrupt_H
#define CoCoA_interrupt_H

//   Copyright (c)  2015  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.
//   -------------------------------------------------------------------------

#include "CoCoA/exception.H"

#include <string>
//using std::string;
#include <iosfwd>
//using std::ostream;

namespace CoCoA
{

  class InterruptReceived: public exception
  {
  private:
    static const char* const ourExceptionMesg;
  public:
    InterruptReceived(const char* const context): exception(ourExceptionMesg, context) {};
    InterruptReceived(const std::string& context): exception(ourExceptionMesg, context) {};
    ~InterruptReceived(); // automatically resets interrupt flag
  private: // no data members (use those of CoCoA::exception)
  };


  void CheckForInterrupt(const char* const context);
  void CheckForInterrupt(const std::string& context);

  std::ostream& operator<<(std::ostream& out, const InterruptReceived& intr);


} // end of namespace CoCoA



// RCS header/log in the next few lines
// $Header: /Volumes/Home_1/cocoa/cvs-repository/CoCoALib-0.99/include/CoCoA/interrupt.H,v 1.3 2015/06/26 14:58:03 abbott Exp $
// $Log: interrupt.H,v $
// Revision 1.3  2015/06/26 14:58:03  abbott
// Summary: Now InterruptReceived derives from CoCoA::exception; CheckForInterrupt requires context string.
// Author: JAA
//
// Revision 1.2  2015/06/25 16:09:30  abbott
// Summary: InterruptReceived ctor now requires string arg; added printing.
// Author: JAA
//
// Revision 1.1  2015/05/20 14:44:58  abbott
// Summary: New fns for responding to interrupts
// Author: JAA
//
//

#endif
